// $Id: Message.java,v 1.1 2005/01/10 20:04:01 jwalter Exp $
package net.jsa;

/**
 * @version $Revision: 1.1 $ $Date: 2005/01/10 20:04:01 $
 * @author Joakim Waltersson
 */
public class Message extends CommunicationEntity {
    public static final int TYPE_AUTHREQUEST = 0;
    public static final int TYPE_TEXT = 1;
    public static final int TYPE_CONTACTS = 2;
    
    public static final int STATUS_SENDING = 0;
    public static final int STATUS_SENT = 1;
    public static final int STATUS_FAILED = 2;
    public static final int STATUS_RECEIVED = 3;
    public static final int STATUS_READ = 4;
    public static final int STATUS_IGNORED = 5;
    public static final int STATUS_QUEUED = 6;
    
    public static final int FAILUREREASON_MISC_ERROR = 1;
    public static final int FAILUREREASON_USER_NOT_FOUND = 2;
    public static final int FAILUREREASON_USER_NOT_ONLINE = 3;
    public static final int FAILUREREASON_USER_BLOCKED = 4;
    public static final int FAILUREREASON_TYPE_UNSUPPORTED = 5;
    public static final int FAILUREREASON_SENDER_NOT_FRIEND = 6;
    public static final int FAILUREREASON_SENDER_NOT_AUTHORISED = 7;
    
    private int type;
    private int status;
    private int failureReason;
    private String body;
    /**
     * @return Returns the body.
     */
    public String getBody() {
        return body;
    }
    public void setBody(String body) {
        this.body = body;
    }
    /**
     * @return Returns the failureReason.
     */
    public int getFailureReason() {
        return failureReason;
    }
    /**
     * @return Returns the status.
     */
    public int getStatus() {
        return status;
    }
    /**
     * @return Returns the type.
     */
    public int getType() {
        return type;
    }
}
