package net.jsa.client.swt;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Observable;
import java.util.Observer;

import net.jsa.connector.AbstractSkypeAPIConnector;
import net.jsa.connector.windows.SkypeAPIConnector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.SWTException;
import org.eclipse.swt.custom.TableCursor;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.ImageLoader;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;

/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
/**
 * Copyright (C) 2004  B. Lamot
 ***********************************************************
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 ************************************************************
 *
 * Part of the swt client example.
 * This is a window with a display text area and a input field.
 * 
 * 1.3		Bart	Added SWTException catches in the init part, online,jpg and na.jpg not found
 */
public class swtChatWindow implements Observer {

    private Text outputText;
    private Text inputText;
    private Shell shell;
    private Display display;
    private static final int WINDOW_WIDTH = 500;
    private static final int WINDOW_HEIGHT = 200;
    private Table table;
    private AbstractSkypeAPIConnector msgr = new SkypeAPIConnector();
    private Map userMap = new HashMap();
    private Map tableItemMap = new HashMap();
    public Image onlineImg;
    public Image naImg;
    
    private void init() {
        ImageLoader loader = new ImageLoader();
        try {
        	final ImageData[] onlineImgData = loader.load("online.jpg");
        	onlineImg = new Image(display, onlineImgData[0]);
        } catch (SWTException se) {
        	System.err.println("online.jpg not found");
        }
        try {
        final ImageData[] naImgData = loader.load("na.jpg");
        naImg = new Image(display, naImgData[0]);
        } catch (SWTException se) {
        	System.err.println("na.jpg not found");
        }
        
        shell = new Shell();
        shell.setSize(328, 630);
        shell.setText("SWT Skype");

        final TabFolder tabFolder = new TabFolder(shell, SWT.NONE);
        tabFolder.setBounds(-1, 40, 320, 555);

        final TabItem tabItem = new TabItem(tabFolder, SWT.NONE);
        tabItem.setText("Contacts");

        final Composite composite = new Composite(tabFolder, SWT.NONE);
        tabItem.setControl(composite);
        
        table = new Table(composite, SWT.BORDER | SWT.MULTI | SWT.FULL_SELECTION);
        table.setBounds(-1, -1, 312, 525);
        table.setLinesVisible(false);
        table.setHeaderVisible(false);
        Menu menu = new Menu(table);
        MenuItem menuItem = new MenuItem(menu, 0);
        menuItem.setText("History");
        table.setMenu(menu);
        table.addMouseListener(new MouseAdapter() {
            public void mouseUp(MouseEvent evt) {
                System.out.println("table.mouseUp, event=" + evt);
                System.err.println(evt.getSource().toString());
                //TODO add your code for table.mouseUp
            }
        });

        final TableColumn statusColumn = new TableColumn(table, SWT.NONE);
        statusColumn.setWidth(100);
        statusColumn.setText("Contact");
        final TableCursor cursor = new TableCursor(table, SWT.NONE);
        cursor.addSelectionListener(new SelectionAdapter() {
            // when the TableEditor is over a cell, select the corresponding row in 
            // the table
            public void widgetSelected(SelectionEvent e) {
                //System.err.println("widgetSelected");
                table.setSelection(new TableItem[] {cursor.getRow()});
            }
        });
        menuItem.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent evt) {
                Object selected = table.getSelection()[0].getData();
                if (selected instanceof UserItem) {
                    final UserItem selectedUser = (UserItem) selected;
                    ArrayList history = new ArrayList();
                    
                    display.asyncExec(new Runnable() {
                        public void run() {
                            Shell shell = new Shell(display);
                            shell.setText("History for " + selectedUser.getFullName());
                            MessageHistoryDialog mhd = new MessageHistoryDialog(shell, 0, null);
                            //shell.layout();
                            mhd.init();
                            shell.layout();
                            shell.open();
                            new HistoryThread(selectedUser.getHandle(), mhd, msgr).start();
                        }
                    });
                    //msgr.sendMessage("SEARCH MESSAGES "
                    //        + selectedUser.getHandle());
                }
                //System.out.println("display history for " + );
                //TODO add your code for menuItem.widgetSelected
            }
        });

        final TabItem tabItem_1 = new TabItem(tabFolder, SWT.NONE);
        tabItem_1.setText("Console");

        final Composite composite2 = new Composite(tabFolder, SWT.NONE);
        tabItem_1.setControl(composite2);

        outputText = new Text(composite2,  SWT.BORDER | SWT.WRAP | SWT.MULTI | SWT.V_SCROLL);
        outputText.setBounds(0,0,310,495);

        inputText = new Text(composite2, SWT.BORDER);
        inputText.setBounds(0, 497, 260, 30);
        
        final Button button = new Button(composite2, SWT.NONE);
        button.setBounds(260, 497, 50, 30);
        //button.setBounds(5, 5, 50, 30);
        button.setText("&Send");
        button.addListener(SWT.MouseDown, new Listener() {
            public void handleEvent(Event e) {
                onSendButton();
            }
        });

        final ToolBar toolBar = new ToolBar(shell, SWT.NONE);
        toolBar.setBounds(0, 0, 320, 40);

        final ToolItem toolItem = new ToolItem(toolBar, SWT.PUSH);
        toolItem.setToolTipText("Get Province of contact");
        toolItem.setText("Province");
        toolItem.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                //System.err.println("toolItem");
                String handle = (String) tableItemMap.get(cursor.getRow());
                msgr.sendMessage("get user " + handle + " province ");
                //System.err.println(handle);
                //table.setSelection(new TableItem[] {cursor.getRow()});
            }
        });


        shell.setDefaultButton(button);
        outputText.setEditable(false);

    }
    private void listUsers() {
        Iterator handles = userMap.keySet().iterator();
        while (handles.hasNext()) {
            String handle = (String) handles.next();
            UserItem user = (UserItem) userMap.get(handle);
            System.out.println(handle + ":" + user.getFullName() + "("
                    + user.getOnlineStatus() + ")");
        }
    }
    private void onSendButton() {
        final String msg = inputText.getText();
        if (msg.equalsIgnoreCase("listusers")) {
            listUsers();
            return;
        }
        System.out.println("onSendButton -->"+msg+"<--");
        display.asyncExec(new Runnable() {
            public void run() {

                try {
                    //send the msg
                	msgr.sendMessage(msg);
                    //inputText.setText("");
                    //inputText.setFocus();
                    //outputText.setSelection(outputText.getCharCount(), outputText.getCharCount());
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }
    
    public void open() {
        display = new Display();
        shell = new Shell(display);
        init();
        shell.layout();
        shell.open();
        dostuff();

        while (!shell.isDisposed()) {
            if (!display.readAndDispatch())
                display.sleep();
        }
        destroy();
        display.dispose();
        System.exit(0);
    }
    public static void main(String args[]) {
        swtChatWindow my_main = new swtChatWindow();
        my_main.open();
	}

    /**
	 *  
	 */
	private void destroy() {
		System.out.println("(swt)Main.destroy()");
        msgr.deleteObserver(this);
		msgr.destroy();
	}

	/**
	 *  
	 */
	private void dostuff() {
        System.out.println("ds " + this);
		msgr = new SkypeAPIConnector();
        msgr.addObserver(this);
		msgr.initialize();		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.lamot.java.jskype.general.MessageListenerInterface#onMessageReceived(java.lang.String)
	 */
	public void onMessageReceived(String message) {
		if (message.equalsIgnoreCase("SkypeControlAPI")) {
			msgr.sendMessage("GET CURRENTUSERHANDLE");
			msgr.sendMessage("GET USERSTATUS ");
			msgr.sendMessage("SEARCH FRIENDS ");
		} else {
		    handleMessage(new String(message));
            displayMessage(message);
		}
	}
    private void displayMessage(final String msg) {
        if (msg != null && msg.length() > 0) {


            display.asyncExec(new Runnable() {
                public void run() {
                    outputText.append(msg + "\r\n");
                    inputText.setFocus();
                    //shell.forceActive();
                    outputText.setSelection(outputText.getCharCount(), outputText.getCharCount());
                }
            });
        }
    }

    private void handleMessage(String message) {
        int typeIdx = message.indexOf(" ");
        String messageType = message.substring(0, typeIdx);
        System.err.println("messtype=" + messageType);
        message = message.substring(typeIdx + 1);
        if (messageType.equals("USERS")) {
            parseUserList(message);
        } else if (messageType.equals("USER")) {
            parseUserInfo(message);
        }
    }
    private Map userMap0 = new HashMap();
    
    private void parseUserInfo(String userInfo) {
        int handleIdx = userInfo.indexOf(" ");
        String handle = userInfo.substring(0, handleIdx);
        userInfo = userInfo.substring(handleIdx + 1);
        int infoTypeIdx = userInfo.indexOf(" ");
        String infoType = userInfo.substring(0, infoTypeIdx);
        String infoString = userInfo.substring(infoTypeIdx + 1);
        if (infoType.equals("FULLNAME")) {
            if (userMap.containsKey(handle)) {
                UserItem user = (UserItem) userMap.get(handle);
                user.setFullName(infoString);
            }
        }
        if (infoType.equals("ONLINESTATUS")) {
            if (userMap.containsKey(handle)) {
                UserItem user = (UserItem) userMap.get(handle);
                user.setOnlineStatus(infoString);
            }
        }
    }
    private synchronized void parseUserList(String users) {
        System.out.println("pul " + this);
        String[] userHandles = users.split(",");
        for (int i = 0; i < userHandles.length; i++) {
            final String userHandle = userHandles[i].trim();
            display.syncExec(new Runnable() {
                public void run() {
                    TableItem tableItem = new TableItem(table, SWT.NONE);
                    UserItem user = new UserItem(userHandle, tableItem, display, swtChatWindow.this);
                    userMap.put(userHandle, user);
                    
                    tableItemMap.put(tableItem, userHandle);
                }
            });
        }
        getUserInfo();
    }
    private void getUserInfo() {
        new UserInfoThread(userMap, msgr).start();
    }

    /* (non-Javadoc)
     * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
     */
    public void update(Observable arg0, Object arg1) {
        onMessageReceived((String)arg1);
    }
}
