package net.jsa.connector.test;

import net.jsa.connector.AbstractSkypeAPIConnector;

/**
* Copyright (C) 2004  B. Lamot
 ***********************************************************
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 ************************************************************
 *
 * Test stub of a messenger.
 * Based on the API documentation (examples).
 */
public class SkypeAPIConnector extends AbstractSkypeAPIConnector {

	/* (non-Javadoc)
	 * @see net.lamot.java.jskype.general.MessengerInterface#sendMessage(java.lang.String)
	 */
	public boolean sendMessage(String message) {
		if (message.startsWith("SEARCH")) {
			onMessageReceived(onSearchMessages(message));
			return true;
		}
		if (message.startsWith("GET")) {
			onMessageReceived(onGetMessages(message));
			return true;
		}
		if (message.startsWith("SET")) {
			onMessageReceived(onSetMessages(message));
			return true;
		}
		if (message.startsWith("CALL")) {
					onMessageReceived(onCallMessages(message));
					return true;
		}
		if (message.startsWith("MESSAGE")) {
					onMessageReceived(onMessageMessages(message));
					return true;
		}
		onMessageReceived("ERROR 2: invalid command");
		return false;
	}

	/**
	 * @param message
	 * @return
	 */
	private String onMessageMessages(String message) {
		if (message.startsWith("MESSAGE")) {			
				return "MESSAGE 136 SENDING";
			}
		return "ERROR 26: invalid userhandle";

	}

	/**
	 * @param message
	 * @return
	 */
	private String onCallMessages(String message) {
		if (message.startsWith("CALL")) {			
				return "CALL 49 STATUS ROUTING";
			}
		return "ERROR 34: invalid user handle";
	}

	/**
	 * @param message
	 * @return
	 */
	private String onSetMessages(String message) {
		if (message.startsWith("SET")) {
					message = message.substring(3).trim();
					return message;
			}
		return "ERROR 18 SET: invalid WHAT";
	}

	/**
	 * 
	 * @param message
	 * @return
	 */
	private String onGetMessages(String message) {
		if (message.startsWith("GET USERSTATUS")) {
			return "USERSTATUS ONLINE";
		}
		if (message.startsWith("GET CONNSTATUS")) {
			return "CONNSTATUS ONLINE";
		}
		if (message.startsWith("GET AUDIO_IN")) {
			return "AUDIO_IN SB Audigy 2 ZS audio";
		}
		if (message.startsWith("GET AUDIO_OUT")) {
			return "AUDIO_OUT SB Audigy 2 ZS audio";
		}
		if (message.startsWith("GET CURRENTUSERHANDLE")) {
			return "CURRENTUSERHANDLE blamot";
		}
		if (message.startsWith("GET MUTE")) {
			return "MUTE OFF";
		}
		if (message.startsWith("GET USER")) {
			message = message.substring(8).trim();
			int spaceindex = message.indexOf(" ");
			String username = message.substring(0, spaceindex).trim();
			String prop = message.substring(spaceindex).trim();
			return "USER " + username + " " + prop + " prop_value";
		}
		if (message.startsWith("GET CALL")) {
			message = message.substring(8).trim();
			int spaceindex = message.indexOf(" ");
			String callid = message.substring(0, spaceindex).trim();
			String prop = message.substring(spaceindex).trim();
			return "USER " + callid + " " + prop + " prop_value";
		}
		if (message.startsWith("GET MESSAGE")) {
			message = message.substring(8).trim();
			int spaceindex = message.indexOf(" ");
			String msgid = message.substring(0, spaceindex).trim();
			String prop = message.substring(spaceindex).trim();
			return "USER " + msgid + " " + prop + " prop_value";
		}
		return "ERROR 7 GET: invalid WHAT";
	}

	/**
	 * 
	 * @param message
	 * @return
	 */
	private String onSearchMessages(String message) {
		if (message.startsWith("SEARCH FRIENDS")) {
			return "FRIENDS tim, joe, mike";
		}
		if (message.startsWith("SEARCH USERS")) {
			return "FRIENDS abc, -abc-";
		}
		if (message.startsWith("SEARCH CALLS")) {
			return "CALLS 15, 16, 39";
		}
		if (message.startsWith("SEARCH MISSEDCALLS")) {
			return "CALLS 25, 56";
		}
		if (message.startsWith("SEARCH MESSAGES")) {
			return "MESSAGES 123, 124";
		}
		if (message.startsWith("SEARCH MISSEDMESSAGES")) {
			return ("MESSAGES 123, 124");
		}
		if (message.startsWith("SEARCH USERS")) {
			return "FRIENDS abc, -abc-";
		}
		return "ERROR 2; UNKOWN COMMAND";
	}

	/* (non-Javadoc)
	 * @see net.lamot.java.jskype.general.AbstractMessenger#initialize()
	 */
	public boolean initialize() {		
		return true;
	}

	/* (non-Javadoc)
	 * @see net.lamot.java.jskype.general.AbstractMessenger#destroy()
	 */
	public void destroy() {
		
		
	}

}
